package expression.exceptions;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.List;

import expression.*;

/**
 * @author Doschennikov Nikita (me@fymio.us)
 */
public class CheckedNegate extends AbstractExpression {
    private final AbstractExpression operand;

    public CheckedNegate(AbstractExpression operand) {
        this.operand = operand;
    }

    private static int checkedNegate(int n) {
        if (n == Integer.MIN_VALUE) throw new OverflowException("negation");
        return -n;
    }

    @Override public int        evaluate(int x)               { return checkedNegate(operand.evaluate(x)); }
    @Override public int        evaluate(int x, int y, int z) { return checkedNegate(operand.evaluate(x,y,z)); }
    @Override public int        evaluate(List<Integer> vars)  { return checkedNegate(operand.evaluate(vars)); }
    @Override public BigInteger evaluateBi(List<BigInteger> vars) { return operand.evaluateBi(vars).negate(); }
    @Override public BigDecimal evaluateBd(List<BigDecimal> vars) { return operand.evaluateBd(vars).negate(); }

    @Override public String toString()     { return "-(" + operand + ")"; }
    @Override public String toMiniString() {
        if (operand instanceof AbstractBinaryOperation) return "-(" + operand.toMiniString() + ")";
        return "- " + operand.toMiniString();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (!(obj instanceof CheckedNegate)) return false;
        return operand.equals(((CheckedNegate) obj).operand);
    }

    @Override public int hashCode() { return -operand.hashCode(); }
}